package org.jeecg.modules.studytourAddress.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.studytourAddress.entity.StudytourAddress;
import org.jeecg.modules.studytourAddress.service.IStudytourAddressService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 地址表
 * @Author: jeecg-boot
 * @Date:   2025-08-25
 * @Version: V1.0
 */
@Api(tags="地址表")
@RestController
@RequestMapping("/studytourAddress/studytourAddress")
@Slf4j
public class StudytourAddressController extends JeecgController<StudytourAddress, IStudytourAddressService>{
	@Autowired
	private IStudytourAddressService studytourAddressService;
	
	/**
	 * 分页列表查询
	 *
	 * @param studytourAddress
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "地址表-分页列表查询")
	@ApiOperation(value="地址表-分页列表查询", notes="地址表-分页列表查询")
	@GetMapping(value = "/rootList")
	public Result<IPage<StudytourAddress>> queryPageList(StudytourAddress studytourAddress,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		String hasQuery = req.getParameter("hasQuery");
        if(hasQuery != null && "true".equals(hasQuery)){
            QueryWrapper<StudytourAddress> queryWrapper =  QueryGenerator.initQueryWrapper(studytourAddress, req.getParameterMap());
            List<StudytourAddress> list = studytourAddressService.queryTreeListNoPage(queryWrapper);
            IPage<StudytourAddress> pageList = new Page<>(1, 10, list.size());
            pageList.setRecords(list);
            return Result.OK(pageList);
        }else{
            String parentId = studytourAddress.getPid();
            if (oConvertUtils.isEmpty(parentId)) {
                parentId = "0";
            }
            studytourAddress.setPid(null);
            QueryWrapper<StudytourAddress> queryWrapper = QueryGenerator.initQueryWrapper(studytourAddress, req.getParameterMap());
            // 使用 eq 防止模糊查询
            queryWrapper.eq("pid", parentId);
            Page<StudytourAddress> page = new Page<StudytourAddress>(pageNo, pageSize);
            IPage<StudytourAddress> pageList = studytourAddressService.page(page, queryWrapper);
            return Result.OK(pageList);
        }
	}

	 /**
      * 获取子数据
      * @param studytourAddress
      * @param req
      * @return
      */
	//@AutoLog(value = "地址表-获取子数据")
	@ApiOperation(value="地址表-获取子数据", notes="地址表-获取子数据")
	@GetMapping(value = "/childList")
	public Result<IPage<StudytourAddress>> queryPageList(StudytourAddress studytourAddress,HttpServletRequest req) {
		QueryWrapper<StudytourAddress> queryWrapper = QueryGenerator.initQueryWrapper(studytourAddress, req.getParameterMap());
		List<StudytourAddress> list = studytourAddressService.list(queryWrapper);
		IPage<StudytourAddress> pageList = new Page<>(1, 10, list.size());
        pageList.setRecords(list);
		return Result.OK(pageList);
	}

    /**
      * 批量查询子节点
      * @param parentIds 父ID（多个采用半角逗号分割）
      * @return 返回 IPage
      * @param parentIds
      * @return
      */
	//@AutoLog(value = "地址表-批量获取子数据")
    @ApiOperation(value="地址表-批量获取子数据", notes="地址表-批量获取子数据")
    @GetMapping("/getChildListBatch")
    public Result getChildListBatch(@RequestParam("parentIds") String parentIds) {
        try {
            QueryWrapper<StudytourAddress> queryWrapper = new QueryWrapper<>();
            List<String> parentIdList = Arrays.asList(parentIds.split(","));
            queryWrapper.in("pid", parentIdList);
            List<StudytourAddress> list = studytourAddressService.list(queryWrapper);
            IPage<StudytourAddress> pageList = new Page<>(1, 10, list.size());
            pageList.setRecords(list);
            return Result.OK(pageList);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return Result.error("批量查询子节点失败：" + e.getMessage());
        }
    }
	
	/**
	 *   添加
	 *
	 * @param studytourAddress
	 * @return
	 */
	@AutoLog(value = "地址表-添加")
	@ApiOperation(value="地址表-添加", notes="地址表-添加")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StudytourAddress studytourAddress) {
		studytourAddressService.addStudytourAddress(studytourAddress);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param studytourAddress
	 * @return
	 */
	@AutoLog(value = "地址表-编辑")
	@ApiOperation(value="地址表-编辑", notes="地址表-编辑")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StudytourAddress studytourAddress) {
		studytourAddressService.updateStudytourAddress(studytourAddress);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "地址表-通过id删除")
	@ApiOperation(value="地址表-通过id删除", notes="地址表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		studytourAddressService.deleteStudytourAddress(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "地址表-批量删除")
	@ApiOperation(value="地址表-批量删除", notes="地址表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.studytourAddressService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功！");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "地址表-通过id查询")
	@ApiOperation(value="地址表-通过id查询", notes="地址表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<StudytourAddress> queryById(@RequestParam(name="id",required=true) String id) {
		StudytourAddress studytourAddress = studytourAddressService.getById(id);
		if(studytourAddress==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(studytourAddress);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param studytourAddress
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StudytourAddress studytourAddress) {
		return super.exportXls(request, studytourAddress, StudytourAddress.class, "地址表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
		return super.importExcel(request, response, StudytourAddress.class);
    }

}
